# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from .run_correlation_py3 import RunCorrelation


class RunActionCorrelation(RunCorrelation):
    """The workflow run action correlation properties.

    :param client_tracking_id: The client tracking identifier.
    :type client_tracking_id: str
    :param client_keywords: The client keywords.
    :type client_keywords: list[str]
    :param action_tracking_id: The action tracking identifier.
    :type action_tracking_id: str
    """

    _attribute_map = {
        'client_tracking_id': {'key': 'clientTrackingId', 'type': 'str'},
        'client_keywords': {'key': 'clientKeywords', 'type': '[str]'},
        'action_tracking_id': {'key': 'actionTrackingId', 'type': 'str'},
    }

    def __init__(self, *, client_tracking_id: str=None, client_keywords=None, action_tracking_id: str=None, **kwargs) -> None:
        super(RunActionCorrelation, self).__init__(client_tracking_id=client_tracking_id, client_keywords=client_keywords, **kwargs)
        self.action_tracking_id = action_tracking_id
